#  README

The artifact allows users to replicate the results in the
evaluation section of the paper, "Diversity-Driven Automated Verification". 
The original paper is available at: 
https://people.cs.umass.edu/~brun/ICSE22Diva/DivaAcceptedVersion.pdf
The artifact runs our automated proof-script
generation tool, Diva, using pre-trained models of proof scripts.

Our replication artifact is a VirtualBox VM (publicly available on Zenodo at DOI 10.5281/zenodo.5903319)
that has an installation of Diva. We also provide the results found in the paper. 
We provide pre-trained models that
were used in the paper evaluation, and so users can evaluate these models and
generate proof scripts from the CoqGym test set. 
Lastly, we provide the
training examples (proof steps) so that users can train their own models. 

The following are the steps for installing and using the VM. 

1. Load the VM image in VirtualBox (it has been tested with VirtualBox Version 6.1.12).
Once you begin running the VM, if prompted, the password is oopsla.

2. Open a terminal window, and configure the CoqGym environment (in which the tool is run):

`cd Documents/CoqGym/ASTactic`
`opam switch "4.07.1+flambda" && eval $(opam env)`
`export COQ_ROOT=/home/oopsla/Documents/CoqGym/coq`
`export COQBIN=/home/oopsla/Documents/CoqGym/coq/bin/`
`export PATH=/home/oopsla/Documents/CoqGym/coq/bin:$PATH`
`conda activate coq_gym`

3. You can now run Diva with any pre-trained model. The flags for running the model
can be found in `evaluate.py`. Here is a small example of running Diva with one of the model paths for the first 
project (weak-up-to) and the first file in that project: 

`cd ASTactic`
 `python evaluate.py ours gtokp-results --path mod_paths/runs/gtokp/model_000.pth --proj_idx 0 --file_idx 0`

A json file with the result is generated. 

The evaluate command without the `--proj_idx` and  `--file_idx` flags runs all the projects in the 
CoqGym test set.
If you want to evaluate all the projects beyond the first one (weak-up-to), first, build the CoqGym projects:
`cd Documents/coq_projects && make && cd ..`
This command takes a while to finish.

It is recommended to run the evaluate command for a single project at a time. To run the model
for a single project, specify an index for the `--proj_idx` flag.
The test projects list in `evaluate.py` tells you which index belongs to which project.
To run a model for a single file within a project, additionally specify an index for 
the `--file_idx` flag. You may create your own file index mapping. 

The VM itself does not support training models since that requires a GPU.
To train a model, use the compressed proof steps files on your own machine.
